import '../color.js';
import '../spacing.js';
import './overlay.js';
const $_documentContainer = document.createElement('div');
$_documentContainer.setAttribute('style', 'display: none;');

$_documentContainer.innerHTML = `<dom-module id="lumo-menu-overlay">
  <template>
    <style include="lumo-overlay">
      [part="overlay"] {
        animation: 0.2s vaadin-menu-overlay-enter;
        will-change: opacity, transform;
      }

      @keyframes vaadin-menu-overlay-enter {
        0% {
          opacity: 0;
          transform: translateY(-4px);
        }
      }

      /* Small viewport styles */

      :host([phone][phone]) {
        /* Remove padding around the viewport */
        padding: 0;
      }

      :host([phone]) [part="overlay"] {
        animation: 0.15s vaadin-mobile-menu-overlay-enter cubic-bezier(.215, .61, .355, 1);
        border-radius: 0;
        box-shadow: 0 6px 56px 0 var(--lumo-shade-80pct);
        overflow: visible;
        padding: 0;
        position: relative;
      }

      @keyframes vaadin-mobile-menu-overlay-enter {
        0% {
          transform: translateY(150%);
        }
      }

      @supports (mask-image: linear-gradient(#000, #000)) or (-webkit-mask-image: linear-gradient(#000, #000)) {
        /* Gradient fade-out at the top and bottom edges */
        :host([phone]) [part="overlay"]::after {
          content: "";
          pointer-events: none;
          position: absolute;
          top: 0;
          right: 0;
          bottom: 0;
          left: 0;
          background-color: inherit;
          background-image: inherit;
          --_lumo-menu-overlay-mask-image: linear-gradient(#000, transparent 40px, transparent calc(100% - 40px), #000);
          -webkit-mask-image: var(--_lumo-menu-overlay-mask-image);
        }
      }

      /*
        TODO: CSS custom property in \`mask-image\` causes crash in Edge
        see https://developer.microsoft.com/en-us/microsoft-edge/platform/issues/15415089/
      */
      @-moz-document url-prefix() {
        :host([phone]) [part="overlay"]::after {
          mask-image: var(--_lumo-menu-overlay-mask-image);
        }
      }

      /* The content part scrolls instead of the overlay part, because of the gradient fade-out */
      :host([phone][phone]) [part="content"] {
        max-height: 50vh;
        padding: 30px var(--lumo-space-m);
        box-sizing: border-box;
        -webkit-overflow-scrolling: touch;
        overflow: auto;
      }
    </style>
  </template>
</dom-module>`;

document.head.appendChild($_documentContainer);
